Package io.vertx.rxjava.core.net

## Class NetSocket

- java.lang.Object
- - io.vertx.rxjava.core.net.NetSocket

- All Implemented Interfaces:
    `ReadStream<Buffer>`, `StreamBase`, `WriteStream<Buffer>`

      public class NetSocket
      extends Object
      implements ReadStream<Buffer>, WriteStream<Buffer>

  Represents a socket-like interface to a TCP connection on either the client or the server side.

  Instances of this class are created on the client side by an `NetClient` when a connection to a server is made, or on the server side by a `NetServer` when a server accepts a connection.

  It implements both and so it can be used with `Pipe` to pipe data with flow control.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<NetSocket>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NetSocket​(NetSocket delegate)` |
    `NetSocket​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String` | `applicationLayerProtocol()` |
    `Future<Void>` | `close()` | Close the socket
    `NetSocket` | `closeHandler​(Handler<Void> handler)` | Set a `handler` notified when the socket is closed
    `NetSocket` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `Future<Void>` | `end()` | Calls `close()`
    `Future<Void>` | `end​(Buffer data)` | Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
    `NetSocket` | `endHandler​(Handler<Void> endHandler)` | This handler might be called after the close handler when the socket is paused and there are still buffers to deliver.
    `boolean` | `equals​(Object o)` |
    `NetSocket` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the read stream.
    `NetSocket` | `fetch​(long amount)` | Fetch the specified `amount` of elements.
    `NetSocket` | `getDelegate()` |
    `NetSocket` | `handler​(Handler<Buffer> handler)` | Set a data handler.
    `int` | `hashCode()` |
    `String` | `indicatedServerName()` | Returns the SNI server name presented during the SSL handshake by the client.
    `boolean` | `isSsl()` |
    `SocketAddress` | `localAddress()` |
    `SocketAddress` | `localAddress​(boolean real)` | Like `localAddress()` ()} but returns the server local address when `real` is `true`
    `static NetSocket` | `newInstance​(NetSocket arg)` |
    `NetSocket` | `pause()` | Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Buffer>` | `pipe()` | Pause this stream and return a to transfer the elements of this stream to a destination .
    `Future<Void>` | `pipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `SocketAddress` | `remoteAddress()` |
    `SocketAddress` | `remoteAddress​(boolean real)` | Like `remoteAddress()` but returns the proxy remote address when `real` is `true`
    `NetSocket` | `resume()` | Resume reading, and sets the buffer in `flowing` mode.
    `Single<Void>` | `rxClose()` | Close the socket
    `Single<Void>` | `rxEnd()` | Calls `close()`
    `Single<Void>` | `rxEnd​(Buffer data)` | Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
    `Single<Void>` | `rxPipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `Single<Void>` | `rxSendFile​(String filename)` | Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `Single<Void>` | `rxSendFile​(String filename, long offset)` | Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `Single<Void>` | `rxSendFile​(String filename, long offset, long length)` | Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `Single<Void>` | `rxUpgradeToSsl()` | Like `upgradeToSsl()` with the default SSL options, without indicating a server name, without an upgrade message.
    `Single<Void>` | `rxUpgradeToSsl​(Buffer msg)` | Like `upgradeToSsl()` with the default SSL options and without indicating a server name.
    `Single<Void>` | `rxUpgradeToSsl​(SSLOptions sslOptions)` | Upgrade channel to use SSL/TLS.
    `Single<Void>` | `rxUpgradeToSsl​(SSLOptions sslOptions, Buffer msg)` | Like `upgradeToSsl()` without indicating a server name
    `Single<Void>` | `rxUpgradeToSsl​(SSLOptions sslOptions, String serverName)` | Like `upgradeToSsl()` without an upgrade message.
    `Single<Void>` | `rxUpgradeToSsl​(SSLOptions sslOptions, String serverName, Buffer upgrade)` | Upgrade the channel to use SSL/TLS, in other words proceeds to the TLS handshake.
    `Single<Void>` | `rxUpgradeToSsl​(String serverName)` | Like `upgradeToSsl()` with the default SSL options and without an update message.
    `Single<Void>` | `rxUpgradeToSsl​(String serverName, Buffer msg)` | Like `upgradeToSsl()` with the default SSL options.
    `Single<Void>` | `rxWrite​(Buffer data)` | Write some data to the stream.
    `Single<Void>` | `rxWrite​(String str)` | Write a `String` to the connection, encoded in UTF-8.
    `Single<Void>` | `rxWrite​(String str, String enc)` | Write a `String` to the connection, encoded using the encoding `enc`.
    `Future<Void>` | `sendFile​(String filename)` | Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `Future<Void>` | `sendFile​(String filename, long offset)` | Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `Future<Void>` | `sendFile​(String filename, long offset, long length)` | Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `NetSocket` | `setWriteQueueMaxSize​(int maxSize)` | Set the maximum size of the write queue to `maxSize`.
    `NetSocket` | `shutdownHandler​(Handler<Void> handler)` | Set a `handler` notified when the socket is shutdown: the client or server will close the connection within a certain amount of time.
    `SSLSession` | `sslSession()` |
    `Observable<Buffer>` | `toObservable()` |
    `String` | `toString()` |
    `WriteStreamSubscriber<Buffer>` | `toSubscriber()` |
    `Future<Void>` | `upgradeToSsl()` | Like `upgradeToSsl()` with the default SSL options, without indicating a server name, without an upgrade message.
    `Future<Void>` | `upgradeToSsl​(Buffer msg)` | Like `upgradeToSsl()` with the default SSL options and without indicating a server name.
    `Future<Void>` | `upgradeToSsl​(SSLOptions sslOptions)` | Upgrade channel to use SSL/TLS.
    `Future<Void>` | `upgradeToSsl​(SSLOptions sslOptions, Buffer msg)` | Like `upgradeToSsl()` without indicating a server name
    `Future<Void>` | `upgradeToSsl​(SSLOptions sslOptions, String serverName)` | Like `upgradeToSsl()` without an upgrade message.
    `Future<Void>` | `upgradeToSsl​(SSLOptions sslOptions, String serverName, Buffer upgrade)` | Upgrade the channel to use SSL/TLS, in other words proceeds to the TLS handshake.
    `Future<Void>` | `upgradeToSsl​(String serverName)` | Like `upgradeToSsl()` with the default SSL options and without an update message.
    `Future<Void>` | `upgradeToSsl​(String serverName, Buffer msg)` | Like `upgradeToSsl()` with the default SSL options.
    `Future<Void>` | `write​(Buffer data)` | Write some data to the stream.
    `Future<Void>` | `write​(String str)` | Write a `String` to the connection, encoded in UTF-8.
    `Future<Void>` | `write​(String str, String enc)` | Write a `String` to the connection, encoded using the encoding `enc`.
    `String` | `writeHandlerID()` | When a `NetSocket` is created, it may register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.
    `boolean` | `writeQueueFull()` | This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<NetSocket> __TYPE_ARG

  - ### Constructor Detail

    - #### NetSocket

          public NetSocket​(NetSocket delegate)

    - #### NetSocket

          public NetSocket​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public NetSocket getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### toSubscriber

          public WriteStreamSubscriber<Buffer> toSubscriber()

      Specified by:
        `toSubscriber` in interface `WriteStream<Buffer>`

    - #### pipe

          public Pipe<Buffer> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `ReadStream<Buffer>`
      Returns:
        a pipe

    - #### pipeTo

          public Future<Void> pipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### rxPipeTo

          public Single<Void> rxPipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `rxPipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### write

          public Future<Void> write​(Buffer data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### rxWrite

          public Single<Void> rxWrite​(Buffer data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `rxWrite` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### end

          public Future<Void> end​(Buffer data)

      Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### rxEnd

          public Single<Void> rxEnd​(Buffer data)

      Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        `true` if write queue is full

    - #### exceptionHandler

          public NetSocket exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public NetSocket handler​(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public NetSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public NetSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public NetSocket fetch​(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public NetSocket endHandler​(Handler<Void> endHandler)

      This handler might be called after the close handler when the socket is paused and there are still buffers to deliver.

      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Parameters:
        `endHandler` -
      Returns:

    - #### setWriteQueueMaxSize

          public NetSocket setWriteQueueMaxSize​(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public NetSocket drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          public String writeHandlerID()

      When a `NetSocket` is created, it may register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      By default, no handler is registered, the feature must be enabled via `NetClientOptions` or `NetServerOptions`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other connections which are owned by different event loops.

      Returns:
        the write handler ID

    - #### write

          public Future<Void> write​(String str)

      Write a `String` to the connection, encoded in UTF-8.
      Parameters:
        `str` - the string to write
      Returns:
        a future result of the write

    - #### rxWrite

          public Single<Void> rxWrite​(String str)

      Write a `String` to the connection, encoded in UTF-8.
      Parameters:
        `str` - the string to write
      Returns:
        a future result of the write

    - #### write

          public Future<Void> write​(String str,
                                    String enc)

      Write a `String` to the connection, encoded using the encoding `enc`.
      Parameters:
        `str` - the string to write
        `enc` - the encoding to use
      Returns:
        a future completed with the result

    - #### rxWrite

          public Single<Void> rxWrite​(String str,
                                      String enc)

      Write a `String` to the connection, encoded using the encoding `enc`.
      Parameters:
        `str` - the string to write
        `enc` - the encoding to use
      Returns:
        a future completed with the result

    - #### sendFile

          public Future<Void> sendFile​(String filename)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
      Returns:
        a future result of the send operation

    - #### rxSendFile

          public Single<Void> rxSendFile​(String filename)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
      Returns:
        a future result of the send operation

    - #### sendFile

          public Future<Void> sendFile​(String filename,
                                       long offset)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
      Returns:
        a future result of the send operation

    - #### rxSendFile

          public Single<Void> rxSendFile​(String filename,
                                         long offset)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
      Returns:
        a future result of the send operation

    - #### sendFile

          public Future<Void> sendFile​(String filename,
                                       long offset,
                                       long length)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `length` - length
      Returns:
        a future result of the send operation

    - #### rxSendFile

          public Single<Void> rxSendFile​(String filename,
                                         long offset,
                                         long length)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `length` - length
      Returns:
        a future result of the send operation

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Returns:
        the remote address for this connection, possibly `null` (e.g a server bound on a domain socket). If `useProxyProtocol` is set to `true`, the address returned will be of the actual connecting client.

    - #### remoteAddress

          public SocketAddress remoteAddress​(boolean real)

      Like `remoteAddress()` but returns the proxy remote address when `real` is `true`
      Parameters:
        `real` -
      Returns:

    - #### localAddress

          public SocketAddress localAddress()

      Returns:
        the local address for this connection, possibly `null` (e.g a server bound on a domain socket) If `useProxyProtocol` is set to `true`, the address returned will be of the proxy.

    - #### localAddress

          public SocketAddress localAddress​(boolean real)

      Like `localAddress()` ()} but returns the server local address when `real` is `true`
      Parameters:
        `real` -
      Returns:

    - #### end

          public Future<Void> end()

      Calls `close()`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Returns:
        a future completed with the result

    - #### rxEnd

          public Single<Void> rxEnd()

      Calls `close()`
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Returns:
        a future completed with the result

    - #### close

          public Future<Void> close()

      Close the socket
      Returns:
        a future completed with the result

    - #### rxClose

          public Single<Void> rxClose()

      Close the socket
      Returns:
        a future completed with the result

    - #### closeHandler

          public NetSocket closeHandler​(Handler<Void> handler)

      Set a `handler` notified when the socket is closed
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### shutdownHandler

          public NetSocket shutdownHandler​(Handler<Void> handler)

      Set a `handler` notified when the socket is shutdown: the client or server will close the connection within a certain amount of time. This gives the opportunity to the `handler` to close the socket gracefully before the socket is closed.
      Parameters:
        `handler` - the handler notified
      Returns:
        a reference to this, so the API can be used fluently

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl()

      Like `upgradeToSsl()` with the default SSL options, without indicating a server name, without an upgrade message.
      Returns:

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl()

      Like `upgradeToSsl()` with the default SSL options, without indicating a server name, without an upgrade message.
      Returns:

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl​(Buffer msg)

      Like `upgradeToSsl()` with the default SSL options and without indicating a server name.
      Parameters:
        `msg` -
      Returns:

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl​(Buffer msg)

      Like `upgradeToSsl()` with the default SSL options and without indicating a server name.
      Parameters:
        `msg` -
      Returns:

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl​(String serverName)

      Like `upgradeToSsl()` with the default SSL options and without an update message.
      Parameters:
        `serverName` -
      Returns:

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl​(String serverName)

      Like `upgradeToSsl()` with the default SSL options and without an update message.
      Parameters:
        `serverName` -
      Returns:

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl​(String serverName,
                                           Buffer msg)

      Like `upgradeToSsl()` with the default SSL options.
      Parameters:
        `serverName` -
        `msg` -
      Returns:

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl​(String serverName,
                                             Buffer msg)

      Like `upgradeToSsl()` with the default SSL options.
      Parameters:
        `serverName` -
        `msg` -
      Returns:

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl​(SSLOptions sslOptions,
                                           String serverName)

      Like `upgradeToSsl()` without an upgrade message.
      Parameters:
        `sslOptions` -
        `serverName` -
      Returns:

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl​(SSLOptions sslOptions,
                                             String serverName)

      Like `upgradeToSsl()` without an upgrade message.
      Parameters:
        `sslOptions` -
        `serverName` -
      Returns:

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl​(SSLOptions sslOptions,
                                           Buffer msg)

      Like `upgradeToSsl()` without indicating a server name
      Parameters:
        `sslOptions` -
        `msg` -
      Returns:

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl​(SSLOptions sslOptions,
                                             Buffer msg)

      Like `upgradeToSsl()` without indicating a server name
      Parameters:
        `sslOptions` -
        `msg` -
      Returns:

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl​(SSLOptions sslOptions,
                                           String serverName,
                                           Buffer upgrade)

      Upgrade the channel to use SSL/TLS, in other words proceeds to the TLS handshake.

      The `upgrade` message will be sent after the socket is ready to proceed to the TLS handshake in order to avoid data races. In practice is usually send by a server when it sends a message to the client to proceed to the handshake, e.g. `250 STARTTLS` for an SMTP server, it should be `null` on a client

      The server name is sent in the client handshake, it should be `null` on a server.

      Be aware that for this to work SSL must be configured.

      Parameters:
        `sslOptions` - the SSL options
        `serverName` - the server name
        `upgrade` - the upgrade message to send
      Returns:
        a future completed when the connection has been upgraded to SSL

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl​(SSLOptions sslOptions,
                                             String serverName,
                                             Buffer upgrade)

      Upgrade the channel to use SSL/TLS, in other words proceeds to the TLS handshake.

      The `upgrade` message will be sent after the socket is ready to proceed to the TLS handshake in order to avoid data races. In practice is usually send by a server when it sends a message to the client to proceed to the handshake, e.g. `250 STARTTLS` for an SMTP server, it should be `null` on a client

      The server name is sent in the client handshake, it should be `null` on a server.

      Be aware that for this to work SSL must be configured.

      Parameters:
        `sslOptions` - the SSL options
        `serverName` - the server name
        `upgrade` - the upgrade message to send
      Returns:
        a future completed when the connection has been upgraded to SSL

    - #### upgradeToSsl

          public Future<Void> upgradeToSsl​(SSLOptions sslOptions)

      Upgrade channel to use SSL/TLS. Be aware that for this to work SSL must be configured.
      Parameters:
        `sslOptions` - the SSL options
      Returns:
        a future completed when the connection has been upgraded to SSL

    - #### rxUpgradeToSsl

          public Single<Void> rxUpgradeToSsl​(SSLOptions sslOptions)

      Upgrade channel to use SSL/TLS. Be aware that for this to work SSL must be configured.
      Parameters:
        `sslOptions` - the SSL options
      Returns:
        a future completed when the connection has been upgraded to SSL

    - #### isSsl

          public boolean isSsl()

      Returns:
        true if this `NetSocket` is encrypted via SSL/TLS.

    - #### indicatedServerName

          public String indicatedServerName()

      Returns the SNI server name presented during the SSL handshake by the client.
      Returns:
        the indicated server name

    - #### applicationLayerProtocol

          public String applicationLayerProtocol()

      Returns:
        the application-level protocol negotiated during the TLS handshake

    - #### sslSession

          public SSLSession sslSession()

      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.

    - #### newInstance

          public static NetSocket newInstance​(NetSocket arg)